#include "blewrap.h"

BleWrap* BleWrap::_pInstance = NULL;

BleWrap* BleWrap::getInstance(void)
{
 if(_pInstance == NULL)
    {
        _pInstance = new BleWrap();
    }
    
    return(_pInstance);   
}

BleWrap::~BleWrap()
{
    
}

void BleWrap::init()
{
    int err = bt_enable(NULL);
	if (err) {
		printk("Bluetooth init failed (err %d)\n", err);
		return;
	}

	bt_set_name(char_deviceName);

	advertisingParam = BT_LE_ADV_PARAM_INIT(BT_LE_ADV_OPT_CONNECTABLE |
							BT_LE_ADV_OPT_USE_NAME,
							BT_GAP_ADV_FAST_INT_MIN_2,
							BT_GAP_ADV_FAST_INT_MAX_2,
							NULL);

        printk("Bluetooth initialized\n");

        if (IS_ENABLED(CONFIG_SETTINGS)) {
            printk("loading settings\n");
            settings_load();
        }

 		bt_le_adv_stop();        
  
        int rc = bt_le_adv_start(&advertisingParam, ad, ARRAY_SIZE(ad),  NULL,0);    
        if (rc) {
            printk("Advertising failed to start (err %d)\n", rc);
            return;
        }
}

BleWrap::BleWrap(void)
{
    
}

ssize_t BleWrap::readBytes(struct bt_conn *conn, const struct bt_gatt_attr *attr, void *buf, uint16_t len, uint16_t offset)
{		
	const char *value = static_cast<const char* const>(attr->user_data);
	return bt_gatt_attr_read(conn, attr, buf, len, offset, value, strlen(value));
}